package djmil.cordacheckers;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.security.core.annotation.AuthenticationPrincipal;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

import djmil.cordacheckers.cordaclient.CordaClient;
import djmil.cordacheckers.cordaclient.pojo.virtualNodes;

@RestController
public class ApiController {

    @Autowired
    CordaClient cordaclient;

    @GetMapping("/api/badjokes")
    public ResponseEntity<Joke> badJokes() {

        List<virtualNodes> vNodes = cordaclient.getVirtualnode();

        Joke joke = new Joke("What do you call a fly without wings? A walk! " + vNodes.get(1).holdingIdentity().x500Name());

        return ResponseEntity.ok(joke);
    }

    /**
     * 
     * @return a Json list of active games
     */
    @GetMapping("/api/activegames")
    public ResponseEntity<String> dashboard(@AuthenticationPrincipal ApiUserDetails user) {

        return ResponseEntity.ok("{ \"ActiveGames\" : [\"game\", \"GAME\", \""+user.getShortHash()+ "\" ] }" );
    }

}