package djmil.cordacheckers;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.security.core.userdetails.User;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.security.crypto.password.PasswordEncoder;
import org.springframework.stereotype.Service;

@Service
public class ApiUserDetailsService implements UserDetailsService {

    @Autowired
    @Lazy
    private PasswordEncoder encoder;

    @Autowired
    @Lazy
    ApiUserShortHashService apiUserShortHash;

    @Override
    public ApiUserDetails loadUserByUsername(String username) throws UsernameNotFoundException {
        // Load user from database
        // User user = userRepository.findByUsername(username);

        // if (user == null) {
        //     throw new UsernameNotFoundException("User not found");
        // }

        System.out.println("Load user "+username);
        
        User.UserBuilder users = User.builder();
	
        UserDetails alice = users
            .username(username)
            .password(encoder.encode("qaz123"))
            .build();
        
        ApiUserDetails apiUser = new ApiUserDetails(alice, apiUserShortHash.getShortHashBy(username));

        return apiUser;
    }
}
