package djmil.cordacheckers;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.security.config.annotation.authentication.builders.AuthenticationManagerBuilder;
import org.springframework.security.config.annotation.web.builders.HttpSecurity;
import org.springframework.security.config.annotation.web.configuration.EnableWebSecurity;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.crypto.factory.PasswordEncoderFactories;
import org.springframework.security.crypto.password.PasswordEncoder;
import org.springframework.security.web.SecurityFilterChain;

import static org.springframework.security.config.Customizer.withDefaults;

@Configuration
@EnableWebSecurity
public class SecurityConfig {

    @Bean
    PasswordEncoder passwordEncoder() {
        return PasswordEncoderFactories.createDelegatingPasswordEncoder();
    }

    @Autowired
    CustomAuthenticationProvider authenticationProvider;

    @Autowired
    public void configure(AuthenticationManagerBuilder auth) throws Exception {
        auth.authenticationProvider(authenticationProvider);
    }

    // @Bean
    // SecurityFilterChain defaultSecurityFilterChain(HttpSecurity http) throws Exception {
    //     http
    //             .authorizeRequests(authorizeRequests ->
    //                     authorizeRequests.anyRequest().authenticated());
    //             .formLogin(withDefaults());
    //     return http.build();
    //   }

    // @Bean
    // UserDetailsService hardcodedCordaUsers(PasswordEncoder passwordEncoder) {
    //     User.UserBuilder users = User.builder();
	
    //     UserDetails alice = users
    //         .username("alice")
    //         .password(passwordEncoder.encode("qaz123"))
    //         .build();

    //     UserDetails bob = users
    //         .username("bob")
    //         .password(passwordEncoder.encode("qaz123"))
    //         .build();
        
    //     return new InMemoryUserDetailsManager(alice, bob);
    // }

}
