package djmil.cordacheckers.cordaclient.pojo;

import javax.naming.InvalidNameException;
import javax.naming.ldap.LdapName;
import javax.naming.ldap.Rdn;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;

@JsonIgnoreProperties(ignoreUnknown = true)
public record holdingIdentity(String x500Name, String shortHash) { 

    public String getName() throws InvalidNameException {
        LdapName ln = new LdapName(x500Name);

        for(Rdn rdn : ln.getRdns()) {
            if(rdn.getType().equalsIgnoreCase("CN")) {
                return rdn.getValue().toString();
            }
        }

        throw new IllegalArgumentException("CN was not found");
    }

    public boolean isPlayer() throws InvalidNameException {
        LdapName ln = new LdapName(x500Name);

        for(Rdn rdn : ln.getRdns()) {
            if(rdn.getType().equalsIgnoreCase("OU")) {
                return rdn.getValue().toString().equalsIgnoreCase("Player");
            }
        }

        return false;
    }
}
