package djmil.cordacheckers;

import org.junit.jupiter.api.Test;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import djmil.cordacheckers.cordaclient.CordaClient;
import djmil.cordacheckers.cordaclient.pojo.holdingIdentity;
import djmil.cordacheckers.cordaclient.pojo.virtualNodes;

import static org.assertj.core.api.Assertions.assertThat;

import java.io.IOException;
import java.security.GeneralSecurityException;
import java.util.List;

import javax.naming.InvalidNameException;

@SpringBootTest
public class CordaClientTest {
    @Autowired
    CordaClient cordaclient;

    @Test
	void whenGetVirtualnode_thenListHoldingIdentity() throws GeneralSecurityException, IOException, InvalidNameException {
        List<virtualNodes> vNodes = cordaclient.getVirtualnode();

        holdingIdentity identity = vNodes.get(0).holdingIdentity();
		assertThat(identity.getName()).isEqualTo("NotaryRep1");
    }

}
